--- old/usr/src/cmd/truss/print.h	2015-05-27 22:22:01.588533883 -0400
+++ new/usr/src/cmd/truss/print.h	2015-05-27 22:22:01.600639064 -0400
@@ -141,7 +141,9 @@
 #define	ACF	99		/* accept4 flags */
 #define	PFD	100		/* pipe fds[2] */
 #define	GRF	101		/* getrandom flags */
-#define	HID	102		/* hidden argument, don't print */
+#define	PSFCMD	102		/* psecflags(2) command */
+#define PSFLG	103		/* psecflags(2) flags */
+#define	HID	104		/* hidden argument, don't print */
 				/* make sure HID is always the last member */
 
 /*
--- old/usr/src/cmd/truss/systable.c	2015-05-27 22:22:01.991781705 -0400
+++ new/usr/src/cmd/truss/systable.c	2015-05-27 22:22:02.004823662 -0400
@@ -221,7 +221,7 @@
 const struct systable systable[] = {
 { NULL,		8, HEX, HEX, HEX, HEX, HEX, HEX, HEX, HEX, HEX, HEX},
 {"_exit",	1, DEC, NOV, DEC},				/*   1 */
-{ NULL,		8, HEX, HEX, HEX, HEX, HEX, HEX, HEX, HEX, HEX, HEX},
+{"psecflags",	3, DEC, NOV, HEX, PSFCMD, PSFLG},		/*   2 */
 {"read",	3, DEC, NOV, DEC, IOB, UNS},			/*   3 */
 {"write",	3, DEC, NOV, DEC, IOB, UNS},			/*   4 */
 {"open",	3, DEC, NOV, STG, OPN, OCT},			/*   5 */
--- old/usr/src/lib/libc/amd64/Makefile	2015-05-27 22:22:04.793411193 -0400
+++ new/usr/src/lib/libc/amd64/Makefile	2015-05-27 22:22:04.933691812 -0400
@@ -240,6 +240,7 @@
 	processor_bind.o	\
 	processor_info.o	\
 	profil.o		\
+	psecflagsset.o		\
 	putmsg.o		\
 	putpmsg.o		\
 	pwrite.o		\
@@ -491,6 +492,7 @@
 	priocntl.o		\
 	privlib.o		\
 	priv_str_xlate.o	\
+	psecflags.o		\
 	psiginfo.o		\
 	psignal.o		\
 	pt.o			\
--- old/usr/src/lib/libc/common/sys/brk.s	2015-05-27 22:22:05.573515005 -0400
+++ new/usr/src/lib/libc/common/sys/brk.s	2015-05-27 22:22:05.586230876 -0400
@@ -37,5 +37,5 @@
 	ENTRY_NP(_brk_unlocked)
 	SYSTRAP_RVAL1(brk)
 	SYSCERROR
-	RETC
+	RET
 	SET_SIZE(_brk_unlocked)
--- /dev/null	2015-05-27 22:22:06.000000000 -0400
+++ new/usr/src/lib/libc/common/sys/psecflagsset.s	2015-05-27 22:22:06.017281646 -0400
@@ -0,0 +1,23 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2014 <contributor>.  All rights reserved.
+ */
+
+	.file	"psecflagsset.s"
+
+#include <sys/asm_linkage.h>
+#include "SYS.h"
+        
+        SYSCALL2_RVAL1(__psecflagsset,psecflags)
+        RET
+        SET_SIZE(__psecflagsset)
--- old/usr/src/lib/libc/i386/Makefile.com	2015-05-27 22:22:06.204217866 -0400
+++ new/usr/src/lib/libc/i386/Makefile.com	2015-05-27 22:22:06.216825519 -0400
@@ -264,6 +264,7 @@
 	processor_bind.o	\
 	processor_info.o	\
 	profil.o		\
+	psecflagsset.o		\
 	putmsg.o		\
 	putpmsg.o		\
 	pwrite.o		\
@@ -524,6 +525,7 @@
 	priocntl.o		\
 	privlib.o		\
 	priv_str_xlate.o	\
+	psecflags.o		\
 	psiginfo.o		\
 	psignal.o		\
 	pt.o			\
--- /dev/null	2015-05-27 22:22:06.000000000 -0400
+++ new/usr/src/lib/libc/port/gen/psecflags.c	2015-05-27 22:22:06.730170619 -0400
@@ -0,0 +1,30 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2014 <contributor>.  All rights reserved.
+ */
+
+#include <sys/proc.h>
+#include <sys/procset.h>
+#include <sys/syscall.h>
+
+extern int __psecflagsset(procset_t *, int, uint_t);
+
+int
+psecflags(idtype_t idtype, id_t id, psecflags_cmd_t cmd, uint_t arg)
+{
+	procset_t procset;
+
+	setprocset(&procset, POP_AND, idtype, id, P_ALL, 0);
+
+	return (__psecflagsset(&procset, cmd, arg));
+}
--- old/usr/src/lib/libc/port/mapfile-vers	2015-05-27 22:22:06.949034466 -0400
+++ new/usr/src/lib/libc/port/mapfile-vers	2015-05-27 22:22:06.962154352 -0400
@@ -2940,6 +2940,7 @@
 	option_to_attr;
 	__priv_bracket;
 	__priv_relinquish;
+	psecflags;
 	pset_assign_forced;
 	pset_bind_lwp;
 	_psignal;
--- old/usr/src/lib/libc/port/sys/sbrk.c	2015-05-27 22:22:07.536897314 -0400
+++ new/usr/src/lib/libc/port/sys/sbrk.c	2015-05-27 22:22:07.551950539 -0400
@@ -24,8 +24,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #pragma weak _sbrk = sbrk
 #pragma weak _brk = brk
 
@@ -40,12 +38,11 @@
 #include "mtlib.h"
 #include "libc.h"
 
-extern int _end;
-void *_nd = &_end;
+void *_nd = NULL;
 mutex_t __sbrk_lock = DEFAULTMUTEX;
 
-extern int _brk_unlocked(void *);
-extern void *_sbrk_unlocked(intptr_t);
+extern intptr_t _brk_unlocked(void *);
+void *_sbrk_unlocked(intptr_t);
 
 /*
  * The break must always be at least 8-byte aligned
@@ -87,8 +84,15 @@
 void *
 _sbrk_unlocked(intptr_t addend)
 {
-	char *old_brk = BRKALIGN(_nd);
-	char *new_brk = BRKALIGN(old_brk + addend);
+	char *old_brk;
+	char *new_brk;
+
+	if (_nd == NULL) {
+		_nd = (void *)_brk_unlocked(0);
+	}
+
+	old_brk = BRKALIGN(_nd);
+	new_brk = BRKALIGN(old_brk + addend);
 
 	if ((addend > 0 && new_brk < old_brk) ||
 	    (addend < 0 && new_brk > old_brk)) {
@@ -134,6 +138,10 @@
 
 	lmutex_lock(&__sbrk_lock);
 
+	if (_nd == NULL) {
+		_nd = (void *)_brk_unlocked(0);
+	}
+
 	old_brk = (uintptr_t)BRKALIGN(_nd);
 	ret_brk = P2ROUNDUP(old_brk, low_align);
 	high_brk = ret_brk + min_size;
@@ -148,7 +156,7 @@
 		return ((void *)-1);
 	}
 
-	if ((brk_result = _brk_unlocked((void *)new_brk)) == 0)
+	if ((brk_result = (int)_brk_unlocked((void *)new_brk)) == 0)
 		_nd = (void *)new_brk;
 	lmutex_unlock(&__sbrk_lock);
 
@@ -165,6 +173,15 @@
 {
 	int result;
 
+	/*
+	 * brk(2) will return the current brk if given an argument of 0, so we
+	 * need to fail it here
+	 */
+	if (new_brk == 0) {
+		errno = ENOMEM;
+		return (-1);
+	}
+
 	if (!primary_link_map) {
 		errno = ENOTSUP;
 		return (-1);
@@ -175,7 +192,7 @@
 	new_brk = BRKALIGN(new_brk);
 
 	lmutex_lock(&__sbrk_lock);
-	if ((result = _brk_unlocked(new_brk)) == 0)
+	if ((result = (int)_brk_unlocked(new_brk)) == 0)
 		_nd = new_brk;
 	lmutex_unlock(&__sbrk_lock);
 
--- old/usr/src/lib/libc/sparc/Makefile.com	2015-05-27 22:22:07.981929630 -0400
+++ new/usr/src/lib/libc/sparc/Makefile.com	2015-05-27 22:22:07.995199531 -0400
@@ -284,6 +284,7 @@
 	processor_bind.o	\
 	processor_info.o	\
 	profil.o		\
+	psecflagsset.o		\
 	putmsg.o		\
 	putpmsg.o		\
 	pwrite.o		\
@@ -556,6 +557,7 @@
 	priocntl.o		\
 	privlib.o		\
 	priv_str_xlate.o	\
+	psecflags.o		\
 	psiginfo.o		\
 	psignal.o		\
 	pt.o			\
--- old/usr/src/lib/libc/sparcv9/Makefile.com	2015-05-27 22:22:08.568171821 -0400
+++ new/usr/src/lib/libc/sparcv9/Makefile.com	2015-05-27 22:22:08.580949070 -0400
@@ -267,6 +267,7 @@
 	processor_bind.o	\
 	processor_info.o	\
 	profil.o		\
+	psecflagsset.o		\
 	putmsg.o		\
 	putpmsg.o		\
 	pwrite.o		\
@@ -516,6 +517,7 @@
 	priocntl.o		\
 	privlib.o		\
 	priv_str_xlate.o	\
+	psecflags.o		\
 	psiginfo.o		\
 	psignal.o		\
 	pt.o			\
--- old/usr/src/lib/libproc/common/P32ton.c	2015-05-27 22:22:09.091947967 -0400
+++ new/usr/src/lib/libproc/common/P32ton.c	2015-05-27 22:22:09.118804298 -0400
@@ -24,8 +24,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/types.h>
 #include <sys/mkdev.h>
 #include <sys/regset.h>
@@ -371,6 +369,8 @@
 	dst->pr_sysexit = src->pr_sysexit;
 	dst->pr_dmodel = src->pr_dmodel;
 
+	(void) memcpy(&dst->pr_secflags, &src->pr_secflags, sizeof (psecflags_t));
+
 	lwpstatus_32_to_n(&src->pr_lwp, &dst->pr_lwp);
 }
 
@@ -744,6 +744,8 @@
 	dst->pr_sysexit = src->pr_sysexit;
 	dst->pr_dmodel = src->pr_dmodel;
 
+	(void) memcpy(&dst->pr_secflags, &src->pr_secflags, sizeof (psecflags_t));
+
 	lwpstatus_n_to_32(&src->pr_lwp, &dst->pr_lwp);
 }
 
--- old/usr/src/lib/libsecdb/help/auths/Makefile	2015-05-27 22:22:11.523612385 -0400
+++ new/usr/src/lib/libsecdb/help/auths/Makefile	2015-05-27 22:22:11.632792496 -0400
@@ -113,6 +113,7 @@
 	SmfValueNDMP.html \
 	AuthReadNDMP.html \
 	SmfValueNWAM.html \
+	SmfValueProcSec.html \
 	SmfValueRouting.html \
 	SmfValueSMB.html \
 	AuthReadSMB.html \
--- old/usr/src/lib/pam_modules/unix_cred/unix_cred.c	2015-05-27 22:22:12.751659836 -0400
+++ new/usr/src/lib/pam_modules/unix_cred/unix_cred.c	2015-05-27 22:22:12.834756084 -0400
@@ -592,6 +592,7 @@
 			goto out;
 		}
 		priv_basicset(def);
+		(void) priv_addset(def, PRIV_PROC_SECFLAGS);
 		errno = 0;
 		if ((pathconf("/", _PC_CHOWN_RESTRICTED) == -1) && (errno == 0))
 			(void) priv_addset(def, PRIV_FILE_CHOWN_SELF);
--- old/usr/src/man/man1/Makefile	2015-05-27 22:22:13.455180342 -0400
+++ new/usr/src/man/man1/Makefile	2015-05-27 22:22:13.506817951 -0400
@@ -301,6 +301,7 @@
 	 	profiles.1			\
 	 	projects.1			\
 	 	ps.1				\
+		psecflags.1			\
 	 	ptree.1				\
 	 	pvs.1				\
 	 	pwd.1				\
--- old/usr/src/man/man5/Makefile	2015-05-27 22:22:15.866549555 -0400
+++ new/usr/src/man/man5/Makefile	2015-05-27 22:22:15.892987717 -0400
@@ -107,6 +107,7 @@
 		regex.5			\
 		regexp.5		\
 		resource_controls.5	\
+		security-flags.5	\
 		smf.5			\
 		smf_bootstrap.5		\
 		smf_method.5		\
--- old/usr/src/pkg/manifests/SUNWcs.man5.inc	2015-05-27 22:22:17.679026383 -0400
+++ new/usr/src/pkg/manifests/SUNWcs.man5.inc	2015-05-27 22:22:17.737362663 -0400
@@ -28,6 +28,7 @@
 file path=usr/share/man/man5/privileges.5
 file path=usr/share/man/man5/rbac.5
 file path=usr/share/man/man5/resource_controls.5
+file path=usr/share/man/man5/security-flags.5
 file path=usr/share/man/man5/smf.5
 file path=usr/share/man/man5/smf_bootstrap.5
 file path=usr/share/man/man5/smf_method.5
--- old/usr/src/pkg/manifests/SUNWcs.mf	2015-05-27 22:22:18.204624857 -0400
+++ new/usr/src/pkg/manifests/SUNWcs.mf	2015-05-27 22:22:18.226771198 -0400
@@ -550,6 +550,7 @@
 file path=lib/svc/manifest/system/manifest-import.xml group=sys mode=0444
 file path=lib/svc/manifest/system/name-service-cache.xml group=sys mode=0444
 file path=lib/svc/manifest/system/pfexecd.xml group=sys mode=0444
+file path=lib/svc/manifest/system/process-security.xml group=sys mode=0444
 file path=lib/svc/manifest/system/rbac.xml group=sys mode=0444
 file path=lib/svc/manifest/system/rmtmpfiles.xml group=sys mode=0444
 file path=lib/svc/manifest/system/sac.xml group=sys mode=0444
@@ -1088,6 +1089,7 @@
 file path=usr/lib/help/auths/locale/C/SmfValueNADD.html
 file path=usr/lib/help/auths/locale/C/SmfValueNDMP.html
 file path=usr/lib/help/auths/locale/C/SmfValueNWAM.html
+file path=usr/lib/help/auths/locale/C/SmfValueProcSec.html
 file path=usr/lib/help/auths/locale/C/SmfValueRouting.html
 file path=usr/lib/help/auths/locale/C/SmfValueSMB.html
 file path=usr/lib/help/auths/locale/C/SmfValueVscan.html
--- old/usr/src/pkg/manifests/consolidation-osnet-osnet-message-files.mf	2015-05-27 22:22:18.772911324 -0400
+++ new/usr/src/pkg/manifests/consolidation-osnet-osnet-message-files.mf	2015-05-27 22:22:18.785275501 -0400
@@ -173,6 +173,7 @@
 file path=usr/lib/help/auths/locale/SmfValueNADD.html
 file path=usr/lib/help/auths/locale/SmfValueNDMP.html
 file path=usr/lib/help/auths/locale/SmfValueNWAM.html
+file path=usr/lib/help/auths/locale/SmfValueProcSec.html
 file path=usr/lib/help/auths/locale/SmfValueRouting.html
 file path=usr/lib/help/auths/locale/SmfValueSMB.html
 file path=usr/lib/help/auths/locale/SmfValueVscan.html
--- old/usr/src/pkg/manifests/system-extended-system-utilities.mf	2015-05-27 22:22:19.198112531 -0400
+++ new/usr/src/pkg/manifests/system-extended-system-utilities.mf	2015-05-27 22:22:19.210213194 -0400
@@ -62,6 +62,7 @@
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/ppriv mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/preap mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/prun mode=0555
+$(i386_ONLY)file path=usr/bin/$(ARCH32)/psecflags mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/psig mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/pstack mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/pstop mode=0555
@@ -82,6 +83,7 @@
 file path=usr/bin/$(ARCH64)/ppriv mode=0555
 file path=usr/bin/$(ARCH64)/preap mode=0555
 file path=usr/bin/$(ARCH64)/prun mode=0555
+file path=usr/bin/$(ARCH64)/psecflags mode=0555
 file path=usr/bin/$(ARCH64)/psig mode=0555
 file path=usr/bin/$(ARCH64)/pstack mode=0555
 file path=usr/bin/$(ARCH64)/pstop mode=0555
@@ -195,6 +197,7 @@
 file path=usr/share/man/man1/ppgsz.1
 file path=usr/share/man/man1/ppriv.1
 file path=usr/share/man/man1/preap.1
+file path=usr/share/man/man1/psecflags.1
 file path=usr/share/man/man1/ptree.1
 file path=usr/share/man/man1/sdiff.1
 file path=usr/share/man/man1/sort.1
@@ -227,6 +230,7 @@
 hardlink path=usr/bin/ppriv target=../../usr/lib/isaexec
 hardlink path=usr/bin/preap target=../../usr/lib/isaexec
 hardlink path=usr/bin/prun target=../../usr/lib/isaexec
+hardlink path=usr/bin/psecflags target=../../usr/lib/isaexec
 hardlink path=usr/bin/psig target=../../usr/lib/isaexec
 hardlink path=usr/bin/pstack target=../../usr/lib/isaexec
 hardlink path=usr/bin/pstop target=../../usr/lib/isaexec
--- old/usr/src/pkg/manifests/system-header.mf	2015-05-27 22:22:19.685129424 -0400
+++ new/usr/src/pkg/manifests/system-header.mf	2015-05-27 22:22:19.819051358 -0400
@@ -1406,6 +1406,7 @@
 file path=usr/include/sys/scsi/targets/smp.h
 $(sparc_ONLY)file path=usr/include/sys/scsi/targets/ssddef.h
 file path=usr/include/sys/scsi/targets/stdef.h
+file path=usr/include/sys/secflags.h
 $(i386_ONLY)file path=usr/include/sys/segment.h
 $(i386_ONLY)file path=usr/include/sys/segments.h
 file path=usr/include/sys/select.h
--- old/usr/src/uts/common/Makefile.files	2015-05-27 22:22:20.429802721 -0400
+++ new/usr/src/uts/common/Makefile.files	2015-05-27 22:22:20.460308192 -0400
@@ -270,6 +270,7 @@
 		priv.o		\
 		priv_const.o	\
 		proc.o		\
+		psecflags.o	\
 		procset.o	\
 		processor_bind.o	\
 		processor_info.o	\
@@ -1929,7 +1930,7 @@
 E1000G_OBJS +=	e1000g_debug.o e1000g_main.o e1000g_alloc.o \
 		e1000g_tx.o e1000g_rx.o e1000g_stat.o \
 		e1000g_osdep.o e1000g_workarounds.o
-		
+
 
 #
 #	Intel 82575 1G NIC driver module
@@ -2051,7 +2052,7 @@
 #	ntxn 10Gb/1Gb NIC driver module
 #
 NTXN_OBJS =	unm_nic_init.o unm_gem.o unm_nic_hw.o unm_ndd.o	\
-			unm_nic_main.o unm_nic_isr.o unm_nic_ctx.o niu.o
+		unm_nic_main.o unm_nic_isr.o unm_nic_ctx.o niu.o
 
 #
 #	Myricom 10Gb NIC driver module
--- old/usr/src/uts/common/c2/audit_event.c	2015-05-27 22:22:21.050218232 -0400
+++ new/usr/src/uts/common/c2/audit_event.c	2015-05-27 22:22:21.094132363 -0400
@@ -136,6 +136,7 @@
 static void	aus_mmap(struct t_audit_data *);
 static void	aus_munmap(struct t_audit_data *);
 static void	aus_priocntlsys(struct t_audit_data *);
+static void	aus_psecflags(struct t_audit_data *);
 static void	aus_setegid(struct t_audit_data *);
 static void	aus_setgroups(struct t_audit_data *);
 static void	aus_seteuid(struct t_audit_data *);
@@ -204,7 +205,7 @@
 		auf_null,	0,
 aui_null,	AUE_EXIT,	aus_exit,	/* 1 exit */
 		auf_null,	S2E_NPT,
-aui_null,	AUE_NULL,	aus_null,	/* 2 (loadable) was forkall */
+aui_null,	AUE_PSECFLAGS,	aus_psecflags,	/* 2 psecflags */
 		auf_null,	0,
 aui_null,	AUE_READ,	aus_null,	/* 3 read */
 		auf_read,	S2E_PUB,
@@ -743,6 +744,20 @@
 	au_uwrite(au_to_arg32(1, "exit status", rval));
 }
 
+/*ARGSUSED*/
+static void
+aus_psecflags(struct t_audit_data *tad)
+{
+	struct a {
+		uintptr_t psp;	/* procset_t */
+		uint_t cmd;	/* psecflags_cmd_t */
+		uint_t arg;
+	} *uap = (struct a *)ttolwp(curthread)->lwp_ap;
+
+	au_uwrite(au_to_arg32(2, "cmd", (uint_t)uap->cmd));
+	au_uwrite(au_to_arg32(3, "arg", (uint_t)uap->arg));
+}
+
 /* acct start function */
 /*ARGSUSED*/
 static void
--- old/usr/src/uts/common/c2/audit_kevents.h	2015-05-27 22:22:21.918804160 -0400
+++ new/usr/src/uts/common/c2/audit_kevents.h	2015-05-27 22:22:21.931467383 -0400
@@ -347,13 +347,10 @@
 #define	AUE_FACCESSAT		309	/* =no obsolete */
 #define	AUE_AUDITON_GETAMASK	310	/* =aa */
 #define	AUE_AUDITON_SETAMASK	311	/* =as */
-
-
+#define	AUE_PSECFLAGS		312	/* =pm psecflags */
 
 /* NOTE: update MAX_KEVENTS below if events are added. */
-
-#define	MAX_KEVENTS		311
-
+#define	MAX_KEVENTS		312
 
 #ifdef __cplusplus
 }
--- old/usr/src/uts/common/exec/elf/elf.c	2015-05-27 22:22:22.376772727 -0400
+++ new/usr/src/uts/common/exec/elf/elf.c	2015-05-27 22:22:22.399403341 -0400
@@ -65,8 +65,10 @@
 #include "elf_impl.h"
 #include <sys/sdt.h>
 #include <sys/siginfo.h>
+#include <sys/random.h>
 
 extern int at_flags;
+extern volatile size_t aslr_max_brk_skew;
 
 #define	ORIGIN_STR	"ORIGIN"
 #define	ORIGIN_STR_SIZE	6
@@ -255,7 +257,8 @@
 	ssize_t		resid;
 	int		fd = -1;
 	intptr_t	voffset;
-	Phdr		*dyphdr = NULL;
+	Phdr		*intphdr = NULL;
+	Phdr		*dynamicphdr = NULL;
 	Phdr		*stphdr = NULL;
 	Phdr		*uphdr = NULL;
 	Phdr		*junk = NULL;
@@ -269,9 +272,11 @@
 	Phdr		*capphdr = NULL;
 	Cap		*cap = NULL;
 	ssize_t		capsize;
+	Dyn		*dyn = NULL;
+	ssize_t		dynsize;
 	int		hasu = 0;
 	int		hasauxv = 0;
-	int		hasdy = 0;
+	int		hasintp = 0;
 	int		branded = 0;
 
 	struct proc *p = ttoproc(curthread);
@@ -364,7 +369,7 @@
 	for (i = nphdrs; i > 0; i--) {
 		switch (phdrp->p_type) {
 		case PT_INTERP:
-			hasauxv = hasdy = 1;
+			hasauxv = hasintp = 1;
 			break;
 		case PT_PHDR:
 			hasu = 1;
@@ -384,6 +389,9 @@
 		case PT_SUNWCAP:
 			capphdr = phdrp;
 			break;
+		case PT_DYNAMIC:
+			dynamicphdr = phdrp;
+			break;
 		}
 		phdrp = (Phdr *)((caddr_t)phdrp + hsize);
 	}
@@ -420,13 +428,14 @@
 		 *	AT_SUN_AUXFLAGS
 		 *	AT_SUN_HWCAP
 		 *	AT_SUN_HWCAP2
+		 *	AT_SUN_SECFLAGS
 		 *	AT_SUN_PLATFORM (added in stk_copyout)
 		 *	AT_SUN_EXECNAME (added in stk_copyout)
 		 *	AT_NULL
 		 *
-		 * total == 9
+		 * total == 10
 		 */
-		if (hasdy && hasu) {
+		if (hasintp && hasu) {
 			/*
 			 * Has PT_INTERP & PT_PHDR - the auxvectors that
 			 * will be built are:
@@ -439,8 +448,8 @@
 			 *
 			 * total = 5
 			 */
-			args->auxsize = (9 + 5) * sizeof (aux_entry_t);
-		} else if (hasdy) {
+			args->auxsize = (10 + 5) * sizeof (aux_entry_t);
+		} else if (hasintp) {
 			/*
 			 * Has PT_INTERP but no PT_PHDR
 			 *
@@ -449,9 +458,9 @@
 			 *
 			 * total = 2
 			 */
-			args->auxsize = (9 + 2) * sizeof (aux_entry_t);
+			args->auxsize = (10 + 2) * sizeof (aux_entry_t);
 		} else {
-			args->auxsize = 9 * sizeof (aux_entry_t);
+			args->auxsize = 10 * sizeof (aux_entry_t);
 		}
 	} else {
 		args->auxsize = 0;
@@ -473,6 +482,44 @@
 		args->auxsize += 4 * sizeof (aux_entry_t);
 	}
 
+	/* If the binary has an explicit ASLR flag, it must be honoured */
+	if (dynamicphdr != NULL) {
+		Dyn *dp;
+
+		dynsize = dynamicphdr->p_filesz;
+		dyn = kmem_alloc(dynsize, KM_SLEEP);
+
+		if ((error = vn_rdwr(UIO_READ, vp, (caddr_t)dyn, dynsize,
+		    (offset_t)dynamicphdr->p_offset, UIO_SYSSPACE, 0, (rlim64_t)0,
+		    CRED(), &resid)) != 0) {
+			uprintf("%s: cannot read .dynamic section\n",
+			    exec_file);
+			goto out;
+		}
+
+		if (resid != 0)
+			goto out;
+
+		dp = dyn;
+		while (dp->d_tag != DT_NULL) {
+			if (dp->d_tag == DT_SUNW_ASLR) {
+				if (dp->d_un.d_val != 0) {
+					curproc->p_secflags.psf_effective |=
+					    PROC_SEC_ASLR;
+					curproc->p_secflags.psf_inherit |=
+					    PROC_SEC_ASLR;
+
+				} else {
+					curproc->p_secflags.psf_effective &=
+					    ~PROC_SEC_ASLR;
+					curproc->p_secflags.psf_inherit &=
+					    ~PROC_SEC_ASLR;
+				}
+			}
+			dp++;
+		}
+	}
+
 	/* Hardware/Software capabilities */
 	if (capphdr != NULL &&
 	    (capsize = capphdr->p_filesz) > 0 &&
@@ -523,12 +570,12 @@
 
 	dtrphdr = NULL;
 
-	if ((error = mapelfexec(vp, ehdrp, nphdrs, phdrbase, &uphdr, &dyphdr,
+	if ((error = mapelfexec(vp, ehdrp, nphdrs, phdrbase, &uphdr, &intphdr,
 	    &stphdr, &dtrphdr, dataphdrp, &bssbase, &brkbase, &voffset, NULL,
 	    len, execsz, &brksize)) != 0)
 		goto bad;
 
-	if (uphdr != NULL && dyphdr == NULL)
+	if (uphdr != NULL && intphdr == NULL)
 		goto bad;
 
 	if (dtrphdr != NULL && dtrace_safe_phdr(dtrphdr, args, voffset) != 0) {
@@ -536,13 +583,13 @@
 		goto bad;
 	}
 
-	if (dyphdr != NULL) {
+	if (intphdr != NULL) {
 		size_t		len;
 		uintptr_t	lddata;
 		char		*p;
 		struct vnode	*nvp;
 
-		dlnsize = dyphdr->p_filesz;
+		dlnsize = intphdr->p_filesz;
 
 		if (dlnsize > MAXPATHLEN || dlnsize <= 0)
 			goto bad;
@@ -550,8 +597,8 @@
 		/*
 		 * Read in "interpreter" pathname.
 		 */
-		if ((error = vn_rdwr(UIO_READ, vp, dlnp, dyphdr->p_filesz,
-		    (offset_t)dyphdr->p_offset, UIO_SYSSPACE, 0, (rlim64_t)0,
+		if ((error = vn_rdwr(UIO_READ, vp, dlnp, intphdr->p_filesz,
+		    (offset_t)intphdr->p_offset, UIO_SYSSPACE, 0, (rlim64_t)0,
 		    CRED(), &resid)) != 0) {
 			uprintf("%s: Cannot obtain interpreter pathname\n",
 			    exec_file);
@@ -760,6 +807,13 @@
 		    ((char *)&aux->a_type -
 		    (char *)bigwad->elfargs));
 		ADDAUX(aux, AT_SUN_AUXFLAGS, auxf);
+
+		/*
+		 * Put the effective security-flags into the aux vector, for
+		 * the sake of flags that need partial (or complete)
+		 * implementation in userland.
+		 */
+		ADDAUX(aux, AT_SUN_SECFLAGS, p->p_secflags.psf_effective);
 		/*
 		 * Hardware capability flag word (performance hints)
 		 * Used for choosing faster library routines.
@@ -900,6 +954,8 @@
 		kmem_free(phdrbase, phdrsize);
 	if (cap != NULL)
 		kmem_free(cap, capsize);
+	if (dyn != NULL)
+		kmem_free(dyn, dynsize);
 	kmem_free(bigwad, sizeof (struct bigwad));
 	return (error);
 }
@@ -1169,7 +1225,7 @@
 	int nphdrs,
 	caddr_t phdrbase,
 	Phdr **uphdr,
-	Phdr **dyphdr,
+	Phdr **intphdr,
 	Phdr **stphdr,
 	Phdr **dtphdr,
 	Phdr *dataphdrp,
@@ -1193,11 +1249,15 @@
 	extern int use_brk_lpg;
 
 	if (ehdr->e_type == ET_DYN) {
+		uint_t flags = 0;
 		/*
 		 * Obtain the virtual address of a hole in the
 		 * address space to map the "interpreter".
 		 */
-		map_addr(&addr, len, (offset_t)0, 1, 0);
+		if (secflag_enabled(curproc, PROC_SEC_ASLR))
+			flags |= _MAP_RANDOMIZE;
+
+		map_addr(&addr, len, (offset_t)0, 1, flags);
 		if (addr == NULL)
 			return (ENOMEM);
 		*voffset = (intptr_t)addr;
@@ -1224,7 +1284,7 @@
 	for (i = nphdrs; i > 0; i--) {
 		switch (phdr->p_type) {
 		case PT_LOAD:
-			if ((*dyphdr != NULL) && (*uphdr == NULL))
+			if ((*intphdr != NULL) && (*uphdr == NULL))
 				return (0);
 
 			ptload = 1;
@@ -1279,6 +1339,13 @@
 				uint_t	szc = curproc->p_brkpageszc;
 				size_t pgsz = page_get_pagesize(szc);
 				caddr_t ebss = addr + phdr->p_memsz;
+				/*
+				 * If we need extra space to keep the BSS an
+				 * integral number of pages in size, some of
+				 * that space may fall beyond p_brkbase, so we
+				 * need to set p_brksize to account for it
+				 * being (logically) part of the brk.
+				 */
 				size_t extra_zfodsz;
 
 				ASSERT(pgsz > PAGESIZE);
@@ -1311,7 +1378,7 @@
 		case PT_INTERP:
 			if (ptload)
 				goto bad;
-			*dyphdr = phdr;
+			*intphdr = phdr;
 			break;
 
 		case PT_SHLIB:
@@ -1345,6 +1412,31 @@
 		*minaddr = (intptr_t)mintmp;
 	}
 
+	if (brkbase != NULL && secflag_enabled(curproc, PROC_SEC_ASLR)) {
+		size_t off;
+		uintptr_t base = (uintptr_t)*brkbase;
+		uintptr_t oend = base + *brksize;
+
+		ASSERT(ISP2(aslr_max_brk_skew));
+
+		(void) random_get_pseudo_bytes((uint8_t *)&off, sizeof (off));
+		base += P2PHASE(off, aslr_max_brk_skew);
+		base = P2ROUNDUP(base, PAGESIZE);
+		*brkbase = (caddr_t)base;
+		/*
+		 * Above, we set *brksize to account for the possibility we
+		 * had to grow the 'brk' in padding out the BSS to a page
+		 * boundary.
+		 *
+		 * We now need to adjust that based on where we now are
+		 * actually putting the brk.
+		 */
+		if (oend > base)
+			*brksize = oend - base;
+		else
+			*brksize = 0;
+	}
+
 	return (0);
 bad:
 	if (error == 0)
--- old/usr/src/uts/common/exec/elf/elf_impl.h	2015-05-27 22:22:22.966405053 -0400
+++ new/usr/src/uts/common/exec/elf/elf_impl.h	2015-05-27 22:22:22.978499762 -0400
@@ -26,8 +26,6 @@
 #ifndef _ELF_ELF_IMPL_H
 #define	_ELF_ELF_IMPL_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifdef	__cplusplus
 extern "C" {
 #endif
--- old/usr/src/uts/common/fs/proc/prsubr.c	2015-05-27 22:22:23.395573964 -0400
+++ new/usr/src/uts/common/fs/proc/prsubr.c	2015-05-27 22:22:23.429759258 -0400
@@ -893,6 +893,7 @@
 	sp->pr_taskid = p->p_task->tk_tkid;
 	sp->pr_projid = p->p_task->tk_proj->kpj_id;
 	sp->pr_zoneid = p->p_zone->zone_id;
+	bcopy(&p->p_secflags, &sp->pr_secflags, sizeof (psecflags_t));
 	hrt2ts(mstate_aggr_state(p, LMS_USER), &sp->pr_utime);
 	hrt2ts(mstate_aggr_state(p, LMS_SYSTEM), &sp->pr_stime);
 	TICK_TO_TIMESTRUC(p->p_cutime, &sp->pr_cutime);
@@ -1116,6 +1117,7 @@
 	sp->pr_taskid = p->p_task->tk_tkid;
 	sp->pr_projid = p->p_task->tk_proj->kpj_id;
 	sp->pr_zoneid = p->p_zone->zone_id;
+	bcopy(&p->p_secflags, &sp->pr_secflags, sizeof (psecflags_t));
 	hrt2ts32(mstate_aggr_state(p, LMS_USER), &sp->pr_utime);
 	hrt2ts32(mstate_aggr_state(p, LMS_SYSTEM), &sp->pr_stime);
 	TICK_TO_TIMESTRUC32(p->p_cutime, &sp->pr_cutime);
--- old/usr/src/uts/common/os/cred.c	2015-05-27 22:22:24.211379583 -0400
+++ new/usr/src/uts/common/os/cred.c	2015-05-27 22:22:24.232088176 -0400
@@ -215,6 +215,8 @@
 	priv_fillset(&CR_LPRIV(kcred));
 	CR_IPRIV(kcred) = *priv_basic;
 
+	priv_addset(&CR_IPRIV(kcred), PRIV_PROC_SECFLAGS);
+
 	/* Not a basic privilege, if chown is not restricted add it to I0 */
 	if (!rstchown)
 		priv_addset(&CR_IPRIV(kcred), PRIV_FILE_CHOWN_SELF);
--- old/usr/src/uts/common/os/exec.c	2015-05-27 22:22:24.842981077 -0400
+++ new/usr/src/uts/common/os/exec.c	2015-05-27 22:22:25.037603435 -0400
@@ -69,6 +69,7 @@
 #include <sys/sdt.h>
 #include <sys/brand.h>
 #include <sys/klpd.h>
+#include <sys/random.h>
 
 #include <c2/audit.h>
 
@@ -99,6 +100,20 @@
 #define	PSUIDFLAGS		(SNOCD|SUGID)
 
 /*
+ * These are consumed within the specific exec modules, but are defined here because
+ *
+ * 1) The exec modules are unloadable, which would make this near useless.
+ *
+ * 2) We want them to be common across all of them, should more than ELF come
+ *    to support them.
+ *
+ * All must be powers of 2.
+ */
+volatile size_t aslr_max_brk_skew = 16 * 1024 * 1024; /* 16MB */
+#pragma weak exec_stackgap = aslr_max_stack_skew      /* Old, compatible name */
+volatile size_t aslr_max_stack_skew = 64 * 1024;      /* 64KB */
+
+/*
  * exece() - system call wrapper around exec_common()
  */
 int
@@ -660,6 +675,10 @@
 		priv_adjust_PA(cred);
 	}
 
+	/* The new image gets the inheritable secflags as its secflags */
+	/* XXX: This probably means we have the wrong secflags when exec fails */
+	secflag_promote(pp);
+
 	/* SunOS 4.x buy-back */
 	if ((vp->v_vfsp->vfs_flag & VFS_NOSETUID) &&
 	    (vattr.va_mode & (VSUID|VSGID))) {
@@ -1774,6 +1793,43 @@
 }
 
 /*
+ * Though the actual stack base is constant, slew the %sp by a random aligned
+ * amount in [0,aslr_max_stack_skew).  Mostly, this makes life slightly more
+ * complicated for buffer overflows hoping to overwrite the return address.
+ *
+ * On some platforms this helps avoid cache thrashing when identical processes
+ * simultaneously share caches that don't provide enough associativity
+ * (e.g. sun4v systems). In this case stack slewing makes the same hot stack
+ * variables in different processes live in different cache sets increasing
+ * effective associativity.
+ */
+size_t
+exec_get_spslew(void)
+{
+#ifdef sun4v
+	static uint_t sp_color_stride = 16;
+	static uint_t sp_color_mask = 0x1f;
+	static uint_t sp_current_color = (uint_t)-1;
+#endif
+	size_t off;
+
+	ASSERT(ISP2(aslr_max_stack_skew));
+
+	if ((aslr_max_stack_skew == 0) ||
+	    !secflag_enabled(curproc, PROC_SEC_ASLR)) {
+#ifdef sun4v
+		uint_t spcolor = atomic_inc_32_nv(&sp_current_color);
+		return ((size_t)((spcolor & sp_color_mask) * SA(sp_color_stride)));
+#else
+		return (0);
+#endif
+	}
+
+	(void) random_get_pseudo_bytes((uint8_t *)&off, sizeof (off));
+	return SA(P2PHASE(off, aslr_max_stack_skew));
+}
+
+/*
  * Initialize a new user stack with the specified arguments and environment.
  * The initial user stack layout is as follows:
  *
@@ -2003,17 +2059,10 @@
 	p->p_flag |= SAUTOLPG;	/* kernel controls page sizes */
 	mutex_exit(&p->p_lock);
 
-	/*
-	 * Some platforms may choose to randomize real stack start by adding a
-	 * small slew (not more than a few hundred bytes) to the top of the
-	 * stack. This helps avoid cache thrashing when identical processes
-	 * simultaneously share caches that don't provide enough associativity
-	 * (e.g. sun4v systems). In this case stack slewing makes the same hot
-	 * stack variables in different processes to live in different cache
-	 * sets increasing effective associativity.
-	 */
 	sp_slew = exec_get_spslew();
 	ASSERT(P2PHASE(sp_slew, args->stk_align) == 0);
+	/* Be certain we don't underflow */
+	VERIFY((curproc->p_usrstack - (size + sp_slew)) < curproc->p_usrstack);
 	exec_set_sp(size + sp_slew);
 
 	as = as_alloc();
--- old/usr/src/uts/common/os/fork.c	2015-05-27 22:22:25.579430412 -0400
+++ new/usr/src/uts/common/os/fork.c	2015-05-27 22:22:25.592353222 -0400
@@ -1087,6 +1087,11 @@
 	cp->p_ppid = pp->p_pid;
 	cp->p_ancpid = pp->p_pid;
 	cp->p_portcnt = pp->p_portcnt;
+	/*
+	 * Security flags are preserved on fork, the inherited copy come into
+	 * effect on exec
+	 */
+	bcopy(&pp->p_secflags, &cp->p_secflags, sizeof (psecflags_t));
 
 	/*
 	 * Initialize watchpoint structures
--- old/usr/src/uts/common/os/grow.c	2015-05-27 22:22:26.082774913 -0400
+++ new/usr/src/uts/common/os/grow.c	2015-05-27 22:22:26.099061251 -0400
@@ -65,13 +65,20 @@
 static int brk_lpg(caddr_t nva);
 static int grow_lpg(caddr_t sp);
 
-int
+intptr_t
 brk(caddr_t nva)
 {
 	int error;
 	proc_t *p = curproc;
 
 	/*
+	 * As a special case to aid the implementation of sbrk(3C), if given a
+	 * new brk of 0, return the current brk.  We'll hide this in brk(3C).
+	 */
+	if (nva == 0)
+		return ((intptr_t)(p->p_brkbase + p->p_brksize));
+
+	/*
 	 * Serialize brk operations on an address space.
 	 * This also serves as the lock protecting p_brksize
 	 * and p_brkpageszc.
@@ -490,10 +497,10 @@
 }
 
 /*
- * Find address for user to map.
- * If MAP_FIXED is not specified, we can pick any address we want, but we will
- * first try the value in *addrp if it is non-NULL.  Thus this is implementing
- * a way to try and get a preferred address.
+ * Find address for user to map.  If MAP_FIXED is not specified, we can pick
+ * any address we want, but we will first try the value in *addrp if it is
+ * non-NULL and _MAP_RANDOMIZE is not set.  Thus this is implementing a way to
+ * try and get a preferred address.
  */
 int
 choose_addr(struct as *as, caddr_t *addrp, size_t len, offset_t off,
@@ -506,7 +513,8 @@
 	if (flags & MAP_FIXED) {
 		(void) as_unmap(as, *addrp, len);
 		return (0);
-	} else if (basep != NULL && ((flags & MAP_ALIGN) == 0) &&
+	} else if (basep != NULL &&
+	    ((flags & (MAP_ALIGN | _MAP_RANDOMIZE)) == 0) &&
 	    !as_gap(as, len, &basep, &lenp, 0, *addrp)) {
 		/* User supplied address was available */
 		*addrp = basep;
@@ -612,6 +620,15 @@
 		return (EINVAL);
 	}
 
+	if ((flags & (MAP_FIXED | _MAP_RANDOMIZE)) == (MAP_FIXED | _MAP_RANDOMIZE)) {
+		return (EINVAL);
+	}
+
+	/* If it's not a fixed allocation and mmap ASLR is enabled, randomize it. */
+	if (((flags & MAP_FIXED) == 0) &&
+	    secflag_enabled(curproc, PROC_SEC_ASLR))
+		flags |= _MAP_RANDOMIZE;
+
 #if defined(__sparc)
 	/*
 	 * See if this is an "old mmap call".  If so, remember this
@@ -630,7 +647,6 @@
 
 
 	if (flags & MAP_ALIGN) {
-
 		if (flags & MAP_FIXED)
 			return (EINVAL);
 
